
#define DEFAULT_TIMEOUT   300    // 300ms
#define DEFAULT_CHECKSUM    0    // disabled

#define WDT03_NoError               0
#define WDT03_ComPortNotOpen        101
#define WDT03_InvalidModuleAddress  102 
#define WDT03_FailedToOpenCom       103
#define WDT03_InvalidChannelNumber  104
#define WDT03_InvalidValue          105
#define WDT03_InvalidResult         106


// *************************************************************
// iCOM   : COM port number, 1~255
// dwBaud : Baud rate
// iModuleAddress : WDT-03 Module Address, 0~255
WORD WDT03_Initialize(int iCOM, DWORD dwBaud, int iModuleAddress);

// *************************************************************
WORD WDT03_ClearAllDO();

// *************************************************************
// iChannel : Channel number for D/O, 0~2
// iValue   : 0=Off, 1=On
WORD WDT03_SetDO(int iChannel, int iValue);

// *************************************************************
// iReadBackValue : Return the D/O read-back value for all channels
WORD WDT03_ReadBackAllDO(int *iReadBackValue);

// *************************************************************
// iChannel : D/O channel number, 0~2
// iValue   : The D/O read-back value for the specified channel
WORD WDT03_ReadBackDO(int iChannel, int *iValue);

// *************************************************************
// iChannel: Temp. channel number, 0~2
// iValue: The Temp. value for the specified channel
WORD WDT03_GetTemp(int iChannel, int *iValue);

// *************************************************************
void WDT03_Close();
