// WDT03MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WDT03MFC.h"
#include "WDT03MFCDlg.h"
#include "WDT03.h"

BOOL  bActive = 0;
DWORD dwRtn;          // Return Code
char  szMsg[80];      // Message String
BYTE  bNewDO0 = 0, bNewDO1 = 0;  // D/O (Alarm) status

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWDT03MFCDlg dialog

CWDT03MFCDlg::CWDT03MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWDT03MFCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWDT03MFCDlg)
	m_Address = 0;
	m_Baud = 0;
	m_COM = 0;
	m_CurSpace = 0;
	m_CurTemp = 0;
	m_LimitSpace = 0;
	m_LimitTemp = 0;
	m_DO0 = 0;
	m_DO1 = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWDT03MFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWDT03MFCDlg)
	DDX_Control(pDX, IDOK, m_Exit);
	DDX_Control(pDX, IDC_BTN_ACTIVE, m_btnActive);
	DDX_Text(pDX, IDC_ADDRESS, m_Address);
	DDX_Text(pDX, IDC_BAUD, m_Baud);
	DDX_Text(pDX, IDC_COM, m_COM);
	DDX_Text(pDX, IDC_CUR_SPACE, m_CurSpace);
	DDX_Text(pDX, IDC_CUR_TEMP, m_CurTemp);
	DDX_Text(pDX, IDC_LIMIT_SPACE, m_LimitSpace);
	DDX_Text(pDX, IDC_LIMIT_TEMP, m_LimitTemp);
	DDX_Text(pDX, IDC_DO0, m_DO0);
	DDX_Text(pDX, IDC_DO1, m_DO1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWDT03MFCDlg, CDialog)
	//{{AFX_MSG_MAP(CWDT03MFCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_ACTIVE, OnBtnActive)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWDT03MFCDlg message handlers

BOOL CWDT03MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_COM        = 1;
	m_Baud       = 9600;
	m_Address    = 1;
	m_LimitSpace = 20;
	m_LimitTemp  = 40;
	m_CurSpace   = 0;
	m_CurTemp    = 0;
	m_DO0        = 0;
	m_DO1        = 0;

	UpdateData( FALSE );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWDT03MFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWDT03MFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWDT03MFCDlg::OnBtnActive() 
{
	// TODO: Add your control notification handler code here
	MSG   msg;
	
	UpdateData( TRUE );

	// *************************************************
	m_btnActive.EnableWindow( FALSE );
	if ( bActive == 1 ) {  // To Stop
		bActive = 0;
		KillTimer( 1 );
		m_btnActive.SetWindowText( "Active" );
		return;
	}

	// *************************************************
	dwRtn = WDT03_Initialize(m_COM, m_Baud, m_Address);
	if ( dwRtn != 0 )
	{
		sprintf(szMsg, "WDT-03 Initialize Error! Error Code=%d", dwRtn );
		MessageBox( szMsg );
		return;
	}

	Sleep( 500 );

	// *************************************************
	// Clear all D/O (Alarm) output
	dwRtn = WDT03_ClearAllDO();
	if ( dwRtn != 0 )
	{
		sprintf(szMsg, "Failed to clear all D/O status! Error Code=%d", dwRtn);
		MessageBox( szMsg );
		return;
	}


	bActive = 1;
	m_btnActive.SetWindowText( "Stop" );
	m_Exit.EnableWindow( FALSE );
	m_btnActive.EnableWindow( TRUE );

	// *************************************************
	// Setup the timer to check the status periodic
	SetTimer(1, DEFAULT_TIMEOUT * 3 + 100, NULL);

	// Check if user cancels this process
	while ( bActive == 1 ) 
	{
		Sleep( 100 );

		while ( PeekMessage(&msg, NULL,  0, 0, PM_REMOVE) ) 
		{
            TranslateMessage(&msg); 
            DispatchMessage(&msg); 
		}
	}

	// *************************************************
	// Waiting for the Timer to finish its job, 
	// we can then close the COM port
	Sleep( DEFAULT_TIMEOUT * 3 + 200 );
	WDT03_Close();

	m_Exit.EnableWindow( TRUE );
	m_btnActive.EnableWindow( TRUE );
}

void CWDT03MFCDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	BOOL fResult;
	ULARGE_INTEGER i64FreeBytes, i64TotalBytes;

	UpdateData( TRUE );

	// *************************************************
	if ( bActive == 0 ) return;

	int iValue;
	dwRtn = WDT03_GetTemp(0, &iValue);
	m_CurTemp = (dwRtn == 0 ? iValue : 9999);

	UpdateData( FALSE );
	if ( bActive == 0 ) return;

	// *************************************************
	// Check if we have to change the Alarm-0 status
	bNewDO0 = m_CurTemp >= m_LimitTemp ? 1 : 0;
	if ( bNewDO0 != m_DO0 ) 
	{
		m_DO0 = bNewDO0;
		if ( bActive == 0 ) return;
		dwRtn = WDT03_SetDO(0, bNewDO0);
	}
	
	UpdateData( FALSE );
	if ( bActive == 0 ) return;

	// Get Disk Space and Free Space
	fResult = GetDiskFreeSpaceEx ("C:\\",
                (PULARGE_INTEGER)&i64FreeBytes,
                (PULARGE_INTEGER)&i64TotalBytes,
                NULL);
	if ( fResult == FALSE ) 
	{
		m_CurSpace = 0;
	} else {
		m_CurSpace = (DWORD)(i64FreeBytes.QuadPart * 100 / i64TotalBytes.QuadPart);
	}

	// *************************************************
	// Check if we have to change the Alarm-1 status
	bNewDO1 = m_LimitSpace >= m_CurSpace ? 1 : 0;
	if ( bNewDO1 != m_DO1 ) 
	{
		m_DO1 = bNewDO1;
		if ( bActive == 0 ) return;
		dwRtn = WDT03_SetDO(1, bNewDO1);
	}
	
	UpdateData( FALSE );
	if ( bActive == 0 ) return;

	CDialog::OnTimer(nIDEvent);
}
