Attribute VB_Name = "i7000"
Option Explicit
'------------------------ Error Message ------------------
Global Const NoError = 0
Global Const FunctionError = 1
Global Const PortError = 2
Global Const BaudRateError = 3
Global Const DataError = 4
Global Const StopError = 5
Global Const ParityError = 6
Global Const CheckSumError = 7
Global Const ComPortNotOpen = 8
Global Const SendThreadCreateError = 9
Global Const SendCmdError = 10
Global Const ReadComStatusError = 11
Global Const ResultStrCheckError = 12
Global Const CmdError = 13
Global Const TimeOut = 15
Global Const ModuleIdError = 17
Global Const AdChannelError = 18
Global Const UnderInputRange = 19
Global Const ExceedInputRange = 20
Global Const InvalidateCounterNo = 21
Global Const InvalidateCounterValue = 22

'----------------------  UART.DLL -----------------------------------------------
Declare Function Open_Com Lib "uart.dll" (ByVal port As Byte, ByVal BaudRate As Long, _
             ByVal cData As Byte, ByVal cParity As Byte, ByVal cStop As Byte) As Integer

Declare Function Close_Com Lib "uart.dll" (ByVal port As Byte) As Boolean


Declare Function Read_Com_Status Lib "uart.dll" (ByVal port As Byte, ByVal buf As String, _
                                                 status As Integer) As Integer

Declare Function Send_Str Lib "uart.dll" (ByVal port As Byte, ByVal buf As String, _
        ByVal TimeOut As Integer) As Integer

Declare Function Receive_Str Lib "uart.dll" (ByVal port As Byte, ByVal szResult As String, _
        ByVal TimeOut As Integer, ByVal Length As Integer, wT As Integer) As Integer
        
Declare Function Send_Cmd Lib "uart.dll" (ByVal port As Byte, ByVal Cmd As String, _
        ByVal TimeOut As Integer, ByVal wChkSum As Integer) As Integer

Declare Function Receive_Cmd Lib "uart.dll" (ByVal port As Byte, _
        ByVal szResult As String, ByVal TimeOut As Integer, ByVal Checksum As Integer, wT As Integer) As Integer


Declare Function Send_Receive_Cmd Lib "uart.dll" (ByVal port As Byte, ByVal szCmd As String, _
        ByVal szResult As String, ByVal TimeOut As Integer, ByVal Checksum As Integer, wT As Integer) As Integer

'----------------------  I7000.DLL --------------------------------------------
Declare Function ReadConfigStatus Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function Test Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogIn Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInFsr Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInHex Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogIn8 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
                                                               
Declare Function In8_7017 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
                                                               
Declare Function AnalogOut Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function AnalogOutReadBack Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function DigitalOut Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
                
Declare Function DigitalOut_7016 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
                
Declare Function DigitalOutReadBack Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function DigitalIn Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DigitalInCounterRead Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearDigitalInCounter Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DigitalInLatch Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearDigitalInLatch Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function ThermocoupleOpen_7011 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function EnableAlarm Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DisableAlarm Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearLatchAlarm Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetAlarmLimitValue Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadAlarmLimitValue Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadOutputAlarmState Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadEventCounter Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearEventCounter Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function SetLedDisplay_7033 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function GetLedDisplay_7033 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function SetLedDisplay Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function GetLedDisplay Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function SetupLinearMapping Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DisableLinearMapping Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function EnableLinearMapping Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadLinearMappingStatus Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadSourceValueOfLM Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadTargetValueOfLM Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function CounterIn_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadCounterMaxValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetCounterMaxValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String, ByVal MaxValue As Double) As Integer
Declare Function ReadAlarmLimitValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetAlarmLimitValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String, ByVal AlarmValue As Double) As Integer
Declare Function ReadCounterStatus_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearCounter_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadOutputAlarmState_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function EnableCounterAlarm_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DisableCounterAlarm_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function EnableCounterAlarm_7080D Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DisableCounterAlarm_7080D Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetInputSignalMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadInputSignalMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadPresetCounterValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function PresetCounterValue_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String, ByVal PresetValue As Double) As Integer
Declare Function StartCounting_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadModuleMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetModuleMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadLevelVolt_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadMinSignalWidth_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetMinSignalWidth_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String, ByVal MinWidth As Long) As Integer
Declare Function SetGateMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadGateMode_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function DataToLED_7080 Lib "i7000.dll" (w7000 As Integer, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

'--------------------- for 8K series -------------------------------------------
Declare Function AnalogIn_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInFsr_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInHex_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInAll_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetAlarmConnect_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetAlarmLimitValue_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadAlarmLimitValue_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ClearLatchAlarm_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadAlarmMode_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetAlarmMode_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogOut_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogOutReadBack_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadAlarmStatus_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetConfigurationStatus_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadConfigurationStatus_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetStartUpValue_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadStartUpValue_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function DigitalOut_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalOutReadBack_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalIn_8K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalBitOut_8K Lib "i7000.dll" (w7000 As Long, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer






Declare Function AnalogIn_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInFsr_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInHex_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogInAll_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogOut_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function AnalogOutReadBack_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetConfigurationStatus_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadConfigurationStatus_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function SetStartUpValue_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer
Declare Function ReadStartUpValue_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer

Declare Function DigitalInCounterRead_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function ClearDigitalInCounter_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalInLatch_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function ClearDigitalInLatch_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalOut_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalOutReadBack_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalIn_87K Lib "i7000.dll" (dwBuf As Long, fBuf As Single, _
                ByVal SendTo8000 As String, ByVal ReceiveFrom8000 As String) As Integer
Declare Function DigitalBitOut_87K Lib "i7000.dll" (w7000 As Long, f7000 As Single, _
                ByVal SendTo7000 As String, ByVal ReceiveFrom7000 As String) As Integer


                
